/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package baza;


import domen.Nastavnik;
import domen.PredajePredmet;
import domen.Predmet;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author Mare
 */
public class DatabaseBroker {
    
    private Connection connection;

    public void ucitajDriver() throws Exception {
        Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
    }

    public void otvoriKonekciju() throws Exception {
        connection = DriverManager.getConnection("jdbc:odbc:Februar2014Baza"); // DejanOstojicBaza
        connection.setAutoCommit(false); // Zahteva eksplicitnu potvrdu transakcije
    }

    public void zatvoriKonekciju() throws Exception {
        connection.close();
    }

    public void commitTransakcije() throws Exception {
        try {
            connection.commit();
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new Exception("Transakcija nije potvrdjena!");
        }
    }

    public void rollbackTransakcije() throws Exception {
        try {
            connection.rollback();
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new Exception("Transakcija nije potvrdjena!");
        }
    }
    
     public List<Predmet> vratiPredmete() throws Exception {
        List<Predmet> lp = new ArrayList<Predmet>();
        try {
            String sql = "SELECT * FROM Predmet";
            Statement sqlNaredba = connection.createStatement();
            ResultSet rsTabela = sqlNaredba.executeQuery(sql);
            while (rsTabela.next()) {
                int predmetID = rsTabela.getInt("PredmetID");
                String naziv = rsTabela.getString("Naziv");
                int ESPB = rsTabela.getInt("ESPB");
                Predmet p = new Predmet(predmetID, naziv, ESPB);
                lp.add(p);
            }
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new Exception("Greska pri ucitavanju Predmeta!");
        }
        return lp;
    }
     public List<Nastavnik> vratiNastavnike() throws Exception {
        List<Nastavnik> listaNastavnika = new ArrayList<Nastavnik>();
        try {
            String sqlAsistent = "SELECT NastavnikID, ImePrezimeAsistenta, NivoStudija FROM Asistent";
            Statement sqlNaredba = connection.createStatement();
            ResultSet rsTabela = sqlNaredba.executeQuery(sqlAsistent);
            while (rsTabela.next()) {
                Nastavnik nastavnik = new Nastavnik();
                nastavnik.setNastavnikID(rsTabela.getInt("NastavnikID"));
                nastavnik.setImePrezimeAsistenta(rsTabela.getString("ImePrezimeAsistenta"));
                nastavnik.setNivoStudija(rsTabela.getString("NivoStudija"));
                listaNastavnika.add(nastavnik);
                
            }   
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new Exception("Greska pri ucitavanju Nastavnika!");
        }
        try {
            String sqlProfesor = "SELECT NastavnikID, ImePrezimeProfesora, Zvanje FROM Profesor";
            Statement sqlNaredba = connection.createStatement();
            ResultSet rs = sqlNaredba.executeQuery(sqlProfesor);
            while (rs.next()) {
                Nastavnik n = new Nastavnik();
                n.setNastavnikID(rs.getInt("NastavnikID"));
                n.setImePrezimeProfesora(rs.getString("ImePrezimeProfesora"));
                n.setZvanje(rs.getString("Zvanje"));
                listaNastavnika.add(n);
                
            }    
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new Exception("Greska pri ucitavanju Nastavnika!");
        }
        return listaNastavnika;
    }
     
     public void sacuvajAngazovanja(PredajePredmet pp) throws SQLException {
        String sql = "Insert into PredajePredmet values (?,?,?,?)";
        try(PreparedStatement ps = connection.prepareStatement(sql)){ // ovo automatski zatvara resurs u ovom slucaju PreparedStatement
            ps.setInt(1, pp.getNastavnik().getNastavnikID());
            ps.setInt(2, pp.getPredmet().getPredmetID());
            ps.setInt(3, pp.getSemestar());
            ps.setString(4, pp.getStudijskiProgram());

            ps.executeUpdate();
        }

  
     
  
    
}}
