/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package server;

import domen.PredajePredmet;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import kontroler.Kontroler;
import transfer.TransferObjekat;

/**
 *
 * @author Mare
 */
public class NitKlijent extends Thread{
    
    Socket socket;
    boolean kraj;

    public NitKlijent(Socket socket) {
        this.socket=socket;
    }
    
    public void run(){
        try {
            izvrsenjeOperacija();
        } catch (IOException ex) {
            Logger.getLogger(NitKlijent.class.getName()).log(Level.SEVERE, null, ex);
        } catch (ClassNotFoundException ex) {
            Logger.getLogger(NitKlijent.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
    
    public void izvrsenjeOperacija() throws IOException, ClassNotFoundException {
        while (!kraj) {
            ObjectInputStream inSocket = new ObjectInputStream(socket.getInputStream());
            TransferObjekat toZahtev = (TransferObjekat) inSocket.readObject();
            TransferObjekat toOdgovor = new TransferObjekat();
            try {
                switch (toZahtev.getOperacija()) {
                    case TransferObjekat.VRATI_PREDMETE:
                        System.out.println("O: " + TransferObjekat.VRATI_PREDMETE);
                        toOdgovor.setRezultat(Kontroler.vratiObjekat().vratiPredmete());
                        break;
                    case TransferObjekat.VRATI_NASTAVNIKE:
                        System.out.println("O: " + TransferObjekat.VRATI_NASTAVNIKE);
                        toOdgovor.setRezultat(Kontroler.vratiObjekat().vratiNastavnike());
                        break;
                           
                  
                    case TransferObjekat.SACUVAJ_ANGAZOVANJA:
                        System.out.println("O: " + TransferObjekat.SACUVAJ_ANGAZOVANJA);
                        PredajePredmet pp = (PredajePredmet) toZahtev.getParametar(); // citas parametar i kastujes ga u otpremnicu jer znas da je ta klasa (jbg ti si ga poslao sa klijenta)
                        Kontroler.vratiObjekat().sacuvajAngazovanja(pp);
                        toOdgovor.setRezultat(null);
                        toOdgovor.setSuccess(true);
                        break;
                           
                }
            } catch (Exception ex) {
                Logger.getLogger(NitKlijent.class.getName()).log(Level.OFF, ex.getMessage(), ex);
                toOdgovor.setRezultat("Angazovanje nije sacuvano");
                toOdgovor.setIzuzetak(ex);
                toOdgovor.setSuccess(false);
            }
            posaljiOdgovor(toOdgovor);
        }

    }

    private void posaljiOdgovor(TransferObjekat toOdgovor) throws IOException {
        ObjectOutputStream outSocket = new ObjectOutputStream(socket.getOutputStream());
        outSocket.writeObject(toOdgovor);
    }
    
    
}
