/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package baza;

import domen.Predmet;
import domen.PredmetStudijskiProgram;
import domen.StudijskiProgram;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author Mare
 */
public class DatabaseBroker {
    
    private Connection connection;

    public void ucitajDriver() throws Exception {
        Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
    }

    public void otvoriKonekciju() throws Exception {
        connection = DriverManager.getConnection("jdbc:odbc:BazaJanuar2014"); // DejanOstojicBaza
        connection.setAutoCommit(false); // Zahteva eksplicitnu potvrdu transakcije
    }

    public void zatvoriKonekciju() throws Exception {
        connection.close();
    }

    public void commitTransakcije() throws Exception {
        try {
            connection.commit();
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new Exception("Transakcija nije potvrdjena!");
        }
    }

    public void rollbackTransakcije() throws Exception {
        try {
            connection.rollback();
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new Exception("Transakcija nije potvrdjena!");
        }
    }
    public List<StudijskiProgram> vratiStudijskePrograme() throws Exception {
        List<StudijskiProgram> lsp = new ArrayList<StudijskiProgram>();
        try {
            String sql = "SELECT * FROM StudijskiProgram";
            Statement sqlNaredba = connection.createStatement();
            ResultSet rsTabela = sqlNaredba.executeQuery(sql);
            while (rsTabela.next()) {
                int studijskiProgramID = rsTabela.getInt("StudijskiProgramID");
                String naziv = rsTabela.getString("Naziv");
                StudijskiProgram sp = new StudijskiProgram(studijskiProgramID, naziv);
                lsp.add(sp);
            }
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new Exception("Greska pri ucitavanju StudijskogPrograma!");
        }
        return lsp;
    }
    
      public List<Predmet> vratiPredmete() throws Exception {
        List<Predmet> lp = new ArrayList<Predmet>();
        try {
            String sql = "SELECT * FROM Predmet";
            Statement sqlNaredba = connection.createStatement();
            ResultSet rsTabela = sqlNaredba.executeQuery(sql);
            while (rsTabela.next()) {
                int predmetID = rsTabela.getInt("PredmetID");
                String naziv = rsTabela.getString("Naziv");
                int predavanja = rsTabela.getInt("Predavanja");
                int vezbe = rsTabela.getInt("Vezbe");
                int labVezbe = rsTabela.getInt("LabVezbe");
                int espb = rsTabela.getInt("ESPB");
                Predmet p = new Predmet(predmetID, naziv, predavanja, vezbe, labVezbe, espb);
                lp.add(p);
            }
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new Exception("Greska pri ucitavanju Predmeta!");
        }
        return lp;
    }
    
      public void sacuvajStudijskiProgram(PredmetStudijskiProgram psp) throws SQLException {
        String sql = "Insert into PredmetStudijskiProgram values (?,?,?)";
        try(PreparedStatement ps = connection.prepareStatement(sql)){ 
            ps.setInt(1, psp.getStudijskiProgram().getStudijskiProgramID());
            ps.setInt(2, psp.getPredmet().getPredmetID());
            ps.setInt(3, psp.getSemestar());

            ps.executeUpdate();
        }
      }
        
      public boolean viseOd30Bodova(PredmetStudijskiProgram psp)throws SQLException {
	  String sql = "select sum(ESPB) as bodovi from PredmetStudijskiProgram left join Predmet on PredmetStudijskiProgram.PredmetID = Predmet.PredmetID  where StudijskiProgramID = " + psp.getStudijskiProgram().getStudijskiProgramID();
	   Statement sqlNaredba = connection.createStatement();
            ResultSet rsTabela = sqlNaredba.executeQuery(sql);
            int pts = 0;
            if (rsTabela.next()){
	      pts = rsTabela.getInt(1);
            }
            pts = pts + psp.getPredmet().getEspb(); // sabiras trenutni broj bodova sa bodovima ispita koji hoces da dodas;
            if (pts > 30){
	      return true;
            }
            return false;
      }
    
    
}
