/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package kontroler;

import baza.DatabaseBroker;
import domen.Predmet;
import domen.PredmetStudijskiProgram;
import domen.StudijskiProgram;
import java.sql.SQLException;
import java.util.List;

/**
 *
 * @author Mare
 */
public class Kontroler {
    
    private DatabaseBroker db;
    private static Kontroler k;

    private Kontroler() {
        db = new DatabaseBroker();
    }

    public static Kontroler vratiObjekat() {
        if (k == null) {
            k = new Kontroler();
        }
        return k;
    }
    
       public List<StudijskiProgram> vratiStudijskePrograme() throws Exception {
        db.ucitajDriver();
        db.otvoriKonekciju();
        List<StudijskiProgram> listaStudijskihPrograma = db.vratiStudijskePrograme();
        db.commitTransakcije();
        db.zatvoriKonekciju();
        return listaStudijskihPrograma;
    }

    public List<Predmet> vratiPredmete() throws Exception {
        db.ucitajDriver();
        db.otvoriKonekciju();
        List<Predmet> listaPredmeta = db.vratiPredmete();
        db.commitTransakcije();
        db.zatvoriKonekciju();
        return listaPredmeta;
    }

    public void sacuvajStudijskiProgram(PredmetStudijskiProgram psp) throws Exception {
        db.ucitajDriver();
        db.otvoriKonekciju();
        try{
            db.sacuvajStudijskiProgram((PredmetStudijskiProgram) psp); // pokusas da sacuvas
            db.commitTransakcije();  // ako prodje komitujes
        }catch(SQLException e){     // db.sacuvajOtpremnicu metoda baca sql exception ako ne moze da sacuva, mi ovde hvatamo
            db.rollbackTransakcije(); // radimo rollback jer ne zelimo da napravimo situaciju da je sacuvana otpremnica, i recimo prve 3 stavke, a poslednjih 8 nije
            throw e; // bacamo exception da mozemo da ga obradimo kasnije
        }finally{ // uvek na kraju cistimo resurse!
            db.zatvoriKonekciju(); 
        }
    }
    
    public boolean viseOd30Bodova(PredmetStudijskiProgram psp) throws Exception{
	db.ucitajDriver();
        db.otvoriKonekciju();
        boolean res = db.viseOd30Bodova(psp);
        db.commitTransakcije();
        db.zatvoriKonekciju();
        return res;
    }

    
    
}
