/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package server;

import TransferObjekat.TransferObjekat;
import domen.PredmetStudijskiProgram;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.util.logging.Level;
import java.util.logging.Logger;
import kontroler.Kontroler;

/**
 *
 * @author Mare
 */
public class NitKlijent extends Thread{
    
    Socket socket;
    boolean kraj;

    public NitKlijent(Socket socket) {
        this.socket=socket;
    }
    
    public void run(){
        try {
            izvrsenjeOperacija();
        } catch (IOException ex) {
            Logger.getLogger(NitKlijent.class.getName()).log(Level.SEVERE, null, ex);
        } catch (ClassNotFoundException ex) {
            Logger.getLogger(NitKlijent.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
    
    public void izvrsenjeOperacija() throws IOException, ClassNotFoundException {
        while (!kraj) {
            ObjectInputStream inSocket = new ObjectInputStream(socket.getInputStream());
            TransferObjekat toZahtev = (TransferObjekat) inSocket.readObject();
            TransferObjekat toOdgovor = new TransferObjekat();
           try {
                switch (toZahtev.getOperacija()) {
                    case TransferObjekat.VRATI_STUDIJSKE_PROGRAME:
                        System.out.println("O: " + TransferObjekat.VRATI_STUDIJSKE_PROGRAME);
                        toOdgovor.setRezultat(Kontroler.vratiObjekat().vratiStudijskePrograme());
                        break;
                    case TransferObjekat.VRATI_PREDMETE:
                        System.out.println("O: " + TransferObjekat.VRATI_PREDMETE);
                        toOdgovor.setRezultat(Kontroler.vratiObjekat().vratiPredmete());
                        break;
                           
                  
                    case TransferObjekat.SACUVAJ_STUDIJSKI_PROGRAM:
                        System.out.println("O: " + TransferObjekat.SACUVAJ_STUDIJSKI_PROGRAM);
                        PredmetStudijskiProgram psp = (PredmetStudijskiProgram) toZahtev.getParametar();
                        boolean viseOd30Bodova = Kontroler.vratiObjekat().viseOd30Bodova(psp);
                        if (viseOd30Bodova){
			  toOdgovor.setIzuzetak(new java.lang.RuntimeException("максималан број ЕСПБ бодова по студијском програму је 30."));
			  toOdgovor.setSuccess(false);
                        }else{
			  Kontroler.vratiObjekat().sacuvajStudijskiProgram(psp);
			  toOdgovor.setRezultat(null);
			  toOdgovor.setSuccess(true);
                        }
                        break;
                           
                }
            } catch (Exception ex) {
                Logger.getLogger(NitKlijent.class.getName()).log(Level.OFF, ex.getMessage(), ex);
                toOdgovor.setRezultat("Angazovanje nije sacuvano");
                toOdgovor.setIzuzetak(ex);
                toOdgovor.setSuccess(false);
            }
            posaljiOdgovor(toOdgovor);
        }

    }
    private void posaljiOdgovor(TransferObjekat toOdgovor) throws IOException {
        ObjectOutputStream outSocket = new ObjectOutputStream(socket.getOutputStream());
        outSocket.writeObject(toOdgovor);
    }
    
}
