/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package dbb;

import domen.Izdanje;
import domen.Publikacija;
import domen.Vest;
import java.sql.Connection;
import java.sql.Date;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author JOVANA
 */
public class DBBroker {

    Connection konekcija;

    public void otvoriKonekciju() throws SQLException {
        try {
            Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
            konekcija = DriverManager.getConnection("jdbc:odbc:jun2014", "", "");
            konekcija.setAutoCommit(false);
        } catch (ClassNotFoundException ex) {
            Logger.getLogger(DBBroker.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public void commit() {
        try {
            konekcija.commit();
        } catch (SQLException ex) {
            Logger.getLogger(DBBroker.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public void rollback() {
        try {
            konekcija.rollback();
        } catch (SQLException ex) {
            Logger.getLogger(DBBroker.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public void zatvoriKonekciju() {
        try {
            konekcija.close();
        } catch (SQLException ex) {
            Logger.getLogger(DBBroker.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public List<Publikacija> vratiPublikacije() throws SQLException {
        String sql = "Select * from Publikacija";
        Statement s = konekcija.createStatement();
        ResultSet rs = s.executeQuery(sql);
        List<Publikacija> publikacije = new ArrayList<>();
        while (rs.next()) {
            Publikacija p = new Publikacija();
            p.setPublikacijaID(rs.getInt("PublikacijaID"));
            p.setNaziv(rs.getString("Naziv"));
            publikacije.add(p);
        }
        return publikacije;
    }

    public String sacuvajIzdanje(Izdanje i) throws SQLException {
        String poruka = "";
        if (provera(i.getDatum(), i.getBroj())) {
            poruka = "Postoji izdanje sa tim datumom/brojem";
            System.out.println(poruka);
        } else {
            String sql = "Insert into Izdanje values (?,?,?,?)";

            PreparedStatement ps = konekcija.prepareStatement(sql);
            int id = vratiID("Izdanje", "IzdanjeID");

            ps.setInt(1, id);
            ps.setDate(2, new java.sql.Date(i.getDatum().getTime()));
            ps.setInt(3, i.getBroj());
            ps.setInt(4, i.getPublikacija().getPublikacijaID());

            ps.executeUpdate();

            sql = "Insert into Vest values (?,?,?,?)";
            ps = konekcija.prepareStatement(sql);
            List<Vest> vesti = i.getListaVesti();

            for (Vest vest : vesti) {
                ps.setInt(1, id);
                ps.setInt(2, vratiID("Vest", "RB"));
                ps.setString(3, vest.getNaslov());
                ps.setString(4, vest.getTekst());
                ps.executeUpdate();
            }

            poruka = "Izdanje je uspesno sacuvano!";
            System.out.println(poruka);
        }
        return poruka;

    }

    private int vratiID(String tabela, String pk) throws SQLException {
        String sql = "Select MAX(" + pk + ") from " + tabela;
        Statement s = konekcija.createStatement();

        ResultSet rs = s.executeQuery(sql);
        rs.next();
        int id = rs.getInt(1);
        return id + 1;

    }

    boolean provera(java.util.Date datum, int broj) throws SQLException {
        DateFormat df = new SimpleDateFormat("MM/dd/yyyy");
        String d = df.format(datum);
        String sql = "Select count(*) as total from Izdanje where Datum=#" + d + "# OR Broj=" + broj;
        System.out.println(sql);
        Statement s = konekcija.createStatement();
        ResultSet rs = s.executeQuery(sql);
        rs.next();
        if (rs.getInt(1) > 0) {
            return true;
        } else {
            return false;
        }
    }

    public List<Vest> pronadjiVesti(String tekst, String d) throws ParseException {

        DateFormat dff = new SimpleDateFormat("dd.MM.yyyy");

        List<Vest> listav = new ArrayList<>();
        try {
            String upit = "";
            if (tekst.equals("") && !d.equals("")) {
                java.util.Date datum = dff.parse(d);
                DateFormat df = new SimpleDateFormat("MM/dd/yyyy");
                upit = "SELECT Publikacija.Naziv, Vest.RB, Vest.Naslov, Vest.Tekst\n"
                        + "FROM (Publikacija INNER JOIN Izdanje ON Publikacija.PublikacijaID = Izdanje.PublikacijaID) INNER JOIN Vest ON Izdanje.IzdanjeID = Vest.IzdanjeID\n"
                        + "WHERE Izdanje.Datum=#" + df.format(datum) + "#";
                System.out.println(upit);
            }

            if (!tekst.equals("") && d.equals("")) {
                upit = "SELECT Publikacija.Naziv, Vest.RB, Vest.Naslov, Vest.Tekst\n"
                        + "FROM (Publikacija INNER JOIN Izdanje ON Publikacija.PublikacijaID = Izdanje.PublikacijaID) INNER JOIN Vest ON Izdanje.IzdanjeID = Vest.IzdanjeID\n"
                        + "WHERE Vest.Naslov LIKE '" + tekst + "%' OR Vest.Tekst LIKE '" + tekst + "%'";
                System.out.println(upit);
            }

            if (!tekst.equals("") && !d.equals("")) {
                java.util.Date datum = dff.parse(d);
                DateFormat df = new SimpleDateFormat("MM/dd/yyyy");
                upit = "SELECT Publikacija.Naziv, Vest.RB, Vest.Naslov, Vest.Tekst\n"
                        + "FROM (Publikacija INNER JOIN Izdanje ON Publikacija.PublikacijaID = Izdanje.PublikacijaID) INNER JOIN Vest ON Izdanje.IzdanjeID = Vest.IzdanjeID\n"
                        + "WHERE Vest.Naslov LIKE '" + tekst + "%' OR Vest.Tekst LIKE '" + tekst + "%' OR Izdanje.Datum=#" + df.format(datum) + "#";
                System.out.println(upit);
            }

            Statement s = konekcija.createStatement();
            ResultSet rs = s.executeQuery(upit);
            while (rs.next()) {
                Vest v = new Vest();
                v.setRb(rs.getInt("RB"));
                v.setNaslov(rs.getString("Naslov"));
                v.setTekst(rs.getString("Tekst"));
                Izdanje i = new Izdanje();
                Publikacija p = new Publikacija();
                p.setNaziv(rs.getString("Naziv"));
                i.setPublikacija(p);
                v.setIzdanje(i);
                listav.add(v);
            }
            return listav;
        } catch (Exception ex) {
            ex.printStackTrace();
            return null;
        }

    }
}
