/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package niti;

import domen.Izdanje;
import domen.Publikacija;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import konstante.Konstante;
import logika.Kontroler;
import transfer.TransferObjekatOdgovor;
import transfer.TransferObjekatZahtev;

/**
 *
 * @author JOVANA
 */
public class NitKlijent extends Thread {

    Socket socket;
    private boolean kraj = false;

    public NitKlijent(Socket socket) {
        this.socket = socket;
    }

    @Override
    public void run() {
        izvrsenjeOperacije();
    }

    private void izvrsenjeOperacije() {
        while (!kraj) {
            ObjectInputStream in = null;
            ObjectOutputStream out = null;
            TransferObjekatOdgovor odgovor = null;

            try {
                in = new ObjectInputStream(socket.getInputStream());
                TransferObjekatZahtev toz = (TransferObjekatZahtev) in.readObject();
                odgovor = new TransferObjekatOdgovor();

                switch (toz.getOperacija()) {
                    case Konstante.VRATI_PUBLIKACIJE:
                        System.out.println("O: " + Konstante.VRATI_PUBLIKACIJE);
                        List<Publikacija> publikacije = Kontroler.vratiObjekat().vratiPublikacije();
                        odgovor.setOdgovor(publikacije);
                        odgovor.setRezultat(Konstante.VRATI_PUBLIKACIJE_OK);
                        break;
                    case Konstante.SACUVAJ_IZDANJE:
                        System.out.println("O: " + Konstante.SACUVAJ_IZDANJE);
                        Izdanje i = (Izdanje) toz.getParametar();
                        String poruka = Kontroler.vratiObjekat().sacuvajIzdanje(i);
                        odgovor.setRezultat(poruka);
                        break;

                }

                posaljiOdgovor(odgovor);

            } catch (Exception ex) {
                //Logger.getLogger(NitKlijent.class.getName()).log(Level.SEVERE, null, ex);
                odgovor.setIzuzetak(ex);
                odgovor.setRezultat(ex.getMessage());
            }
        }
    }

    private void posaljiOdgovor(TransferObjekatOdgovor odgovor) throws IOException {
        ObjectOutputStream out = null;
        out = new ObjectOutputStream(socket.getOutputStream());
        out.writeObject(odgovor);
    }

}
