/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package kontroler;

import domen.Advokat;
import domen.Klijent;
import domen.Predmet;
import domen.VrstaPostupka;
import java.io.IOException;
import java.net.UnknownHostException;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import klijent.Komunikacija;
import transfer.TransferObjekat;

/**
 *
 * @author Mare
 */
public class Kontroler {
    
    public static List<Advokat> vratiSveAdvokate() throws UnknownHostException, IOException, ClassNotFoundException {
        ArrayList<Advokat> listaAdvokata = new ArrayList<>();
        TransferObjekat to = new TransferObjekat();
        to.setOperacija(TransferObjekat.VRATI_ADVOKATE);
        Komunikacija.vratiObjekat().posalji(to);
        
        TransferObjekat tos = Komunikacija.vratiObjekat().procitaj();
        
        
        
        return  (List<Advokat>)tos.getRezultat();
    }
    public static List<Klijent> vratiSveKlijente() throws UnknownHostException, IOException, ClassNotFoundException{
        ArrayList<Klijent> listaKlijenata = new ArrayList<Klijent>();
        TransferObjekat to = new TransferObjekat();
        to.setOperacija(TransferObjekat.VRATI_KLIJENTE);
        Komunikacija.vratiObjekat().posalji(to);
        
        TransferObjekat tos = Komunikacija.vratiObjekat().procitaj();
        
        return (List<Klijent>)tos.getRezultat();
                
    }
    public static List<VrstaPostupka> vratiSveVrstePostupaka() throws UnknownHostException, ClassNotFoundException, IOException{
        ArrayList<VrstaPostupka> listaVrstiPostupaka = new ArrayList<>();
        TransferObjekat to = new TransferObjekat();
        to.setOperacija(TransferObjekat.VRATI_VRSTE_POSTUPAKA);
        Komunikacija.vratiObjekat().posalji(to);
        TransferObjekat tos = Komunikacija.vratiObjekat().procitaj();
        
        return (List<VrstaPostupka>)tos.getRezultat();
                
    }
    
    public static TransferObjekat sacuvajSvePredmete(List<Predmet> p) {
        TransferObjekat toz = new TransferObjekat();
        toz.setOperacija(TransferObjekat.SACUVAJ_SVE_PREDMETE);
        toz.setParametar(p);
        try {
            Komunikacija.vratiObjekat().posalji(toz); // sada ovo saljemo serveru i cekamo njegov odgovor. Prelazimo na server u NitKlijent.java fajl
            return Komunikacija.vratiObjekat().procitaj();
        } catch (IOException | ClassNotFoundException ex) {
            Logger.getLogger(Kontroler.class.getName()).log(Level.SEVERE, null, ex);
            return new TransferObjekat(); // ako je exception onda vracam novi trans obj. jer po defaultu je success polje false!
        }
       
    }
    public static int vratiNovuSifruPredmeta() throws UnknownHostException, IOException, ClassNotFoundException {
        
        TransferObjekat to = new TransferObjekat();
        to.setOperacija(TransferObjekat.VRATI_SIFRU_PREDMETA);
        Komunikacija.vratiObjekat().posalji(to);   
        TransferObjekat tos = Komunikacija.vratiObjekat().procitaj();
        return (int) tos.getRezultat();
        
    }
}
