/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package baza;

import domen.Advokat;
import domen.Klijent;
import domen.Predmet;
import domen.VrstaPostupka;
import java.sql.Connection;
import java.util.Date;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 *
 * @author Mare
 */
public class DatabaseBroker {

    private Connection connection;

    public void ucitajDriver() throws Exception {
        Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
    }

    public void otvoriKonekciju() throws Exception {
        connection = DriverManager.getConnection("jdbc:odbc:Novembar2014Baza");
        connection.setAutoCommit(false);
    }

    public void zatvoriKonekciju() throws Exception {
        connection.close();
    }

    public void commitTransakcije() throws Exception {
        try {
            connection.commit();
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new Exception("Transakcija nije potvrdjena!");
        }
    }

    public void rollbackTransakcije() throws Exception {
        try {
            connection.rollback();
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new Exception("Transakcija nije potvrdjena!");
        }
    }

    public List<Advokat> vratiAdvokate() throws Exception {
        List<Advokat> listaAdvokata = new ArrayList<>();
        try {
            String sql = "SELECT * FROM ADVOKAT";
            Statement sqlNaredba = connection.createStatement();
            ResultSet rsTabela = sqlNaredba.executeQuery(sql);
            while (rsTabela.next()) {
                int advokatID = rsTabela.getInt("AdvokatID");
                String ime = rsTabela.getString("Ime");
                String prezime = rsTabela.getString("Prezime");
                int specijalnostZaVrstuPostupka = rsTabela.getInt("SpecijalnostZaVrstuPostupka");
                Advokat advokat = new Advokat(advokatID, ime, prezime, specijalnostZaVrstuPostupka);
                listaAdvokata.add(advokat);

            }
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new Exception("Greska pri ucitavanju Advokata!");
        }
        return listaAdvokata;
    }

    public List<Klijent> vratiKlijente() throws Exception {
        List<Klijent> listaKlijenata = new ArrayList<>();
        try {
            String sql = "SELECT * FROM Klijent";
            Statement sqlNaredba = connection.createStatement();
            ResultSet rsTabela = sqlNaredba.executeQuery(sql);
            while (rsTabela.next()) {
                int klijentID = rsTabela.getInt("KlijentID");
                String ime = rsTabela.getString("Ime");
                String prezime = rsTabela.getString("Prezime");
                String telefon = rsTabela.getString("Telefon");
                String elPosta = rsTabela.getString("ElPosta");
                String adresa = rsTabela.getString("Adresa");
                Klijent klijent = new Klijent(klijentID, ime, prezime, telefon, elPosta, adresa);
                listaKlijenata.add(klijent);
            }
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new Exception("Greska pri ucitavanju Klijenta!");
        }
        return listaKlijenata;

    }

    public List<VrstaPostupka> vratiVrstePostupka() throws Exception {
        List<VrstaPostupka> listaVrstiPostupaka = new ArrayList<VrstaPostupka>();
        try {
            String sql = "SELECT * FROM VrstaPostupka";
            Statement sqlNaredba = connection.createStatement();
            ResultSet rsTabela = sqlNaredba.executeQuery(sql);
            while (rsTabela.next()) {
                int vrstaPostupkaID = rsTabela.getInt("VrstaPostupkaID");
                String naziv = rsTabela.getString("Naziv");
                VrstaPostupka vrstaPostupka = new VrstaPostupka(vrstaPostupkaID, naziv);
                listaVrstiPostupaka.add(vrstaPostupka);
            }
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new Exception("Greska pri ucitavanju vrsti postupka");
        }
        return listaVrstiPostupaka;
    }

    public void sacuvajSvePredmete(List<Predmet> p) throws SQLException {
        List<Predmet> listaPredmeta = p;
        int startId = vratiNovuSifruPredmeta();
        for (Predmet pre : listaPredmeta) {
            pre.setPredmetID(startId); // namestis dobar id za prvi element!
            startId = startId + 1;    // povecas start id za jedan za sledeci iz liste
            System.out.println("ime: " + pre.getNaziv() + ", id: " + pre.getPredmetID() + ", getVrstaPostupkaID: " + pre.getVrstaPostupka().getVrstaPostupkaID());

        }

//        pre.setPredmetID(startId); // namestis dobar id za prvi element!
//        startId = startId + 1;
        // povecas start id za jedan za sledeci iz liste
        
         for (Predmet pre : listaPredmeta) {
//        String sql = "Insert into Predmet values (?,?,?,?,?,?,?)";
//        String sql = "Insert into Predmet  (PredmetID,Naziv,Problem,Datum,AdvokatID,KlijentID,VrstaPostupkaID) values (?,?)";
        String sql = "Insert into Predmet  (PredmetID,Naziv,Problem,Datum,AdvokatID,KlijentID,VrstaPostupkaID) values (?,?,?,?,?,?,?)";
        try (PreparedStatement ps = connection.prepareStatement(sql)) { // isto kao gore
           
            ps.setInt(1, pre.getPredmetID());
              ps.setString(2, pre.getNaziv()); // rb je drugi deo primarnog kljuca, njega kontrolisemo na klijentu
                ps.setString(3, pre.getProblem());
                
                ps.setDate(4, new java.sql.Date(pre.getDatum().getTime()));
                ps.setInt(5, pre.getAdvokat().getAdvokatID());
                ps.setInt(6, pre.getKlijent().getKlijentID());
                ps.setInt(7, pre.getVrstaPostupka().getVrstaPostupkaID());

                ps.executeUpdate();
                System.out.println("UBACEN pre: " + pre.getNaziv() + ", id: "  + pre.getPredmetID());
            }

        }
        System.out.println("GOTOVO SVE!!!!!!!!!!!!!!!");
    }

    public int vratiNovuSifruPredmeta() throws SQLException {
        int noviBroj = -1;
        String sql = "SELECT MAX(PredmetID) as sifra FROM Predmet";
        Statement sqlNaredba = connection.createStatement();
        ResultSet rsTabela = sqlNaredba.executeQuery(sql);
        while (rsTabela.next()) {
            int sifra = rsTabela.getInt("sifra");
            noviBroj = sifra + 1;
        }
        return noviBroj;

    }

}
