/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package kontroler;

import baza.DatabaseBroker;
import domen.Advokat;
import domen.Klijent;
import domen.Predmet;
import domen.VrstaPostupka;
import java.sql.SQLException;
import java.util.List;

/**
 *
 * @author Mare
 */
public class Kontroler {
    
    private DatabaseBroker db;
    private static Kontroler k;

    private Kontroler() {
        db = new DatabaseBroker();
    }

    public static Kontroler vratiObjekat() {
        if (k == null) {
            k = new Kontroler();
        }
        return k;
    }
    
    public List<Advokat> vratiAdvokate() throws Exception {
       db.ucitajDriver();
       db.otvoriKonekciju();
       List<Advokat> listaAdvokata = db.vratiAdvokate();
       db.commitTransakcije();
       db.zatvoriKonekciju();
       return listaAdvokata;
    }
    
    public List<Klijent> vratiKlijente() throws Exception{
        db.ucitajDriver();
        db.otvoriKonekciju();
        List<Klijent> listaKlijenta = db.vratiKlijente();
        db.commitTransakcije();
        db.zatvoriKonekciju();
        return listaKlijenta;
    }
    
    public List<VrstaPostupka> vratiVrstePostupaka() throws Exception{
        db.ucitajDriver();
        db.otvoriKonekciju();
        List<VrstaPostupka> listaVrstiPostupaka = db.vratiVrstePostupka();
        db.commitTransakcije();
        db.zatvoriKonekciju();
        return listaVrstiPostupaka;
    }
    
    public void sacuvajSvePredmete(List<Predmet> p) throws SQLException, Exception{
        db.ucitajDriver();
        db.otvoriKonekciju();
        try{
            System.out.println("SACUVAJ SVE PREDMENTE START!!!");
            db.sacuvajSvePredmete(p);
            System.out.println("SACUVAJ SVE PREDMENTE kraj!!!");
            db.commitTransakcije();
            System.out.println("SACUVAJ SVE PREDMENTE COMMIT!!!");
        }catch(SQLException e){
            System.out.println("OVDE GRESKA");
            db.rollbackTransakcije();
            e.printStackTrace();
            throw e;
        }finally{
            System.out.println("KONACNO ZATVORI");
            db.zatvoriKonekciju(); 
        }
        
    }
    public int vratiNovuSifruPredmeta() throws Exception{
        db.ucitajDriver();
        db.otvoriKonekciju();
        int sifra = db.vratiNovuSifruPredmeta();
        db.commitTransakcije();
        db.zatvoriKonekciju();
        return sifra;
        
    }
        
}
