/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package server;

import domen.Predmet;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import kontroler.Kontroler;
import transfer.TransferObjekat;

/**
 *
 * @author Mare
 */
public class NitKlijent extends Thread{
    
    Socket socket;
    boolean kraj;

    public NitKlijent(Socket socket) {
        this.socket=socket;
    }
    
    public void run(){
        try {
            izvrsenjeOperacija();
        } catch (IOException ex) {
            Logger.getLogger(NitKlijent.class.getName()).log(Level.SEVERE, null, ex);
        } catch (ClassNotFoundException ex) {
            Logger.getLogger(NitKlijent.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
    
    public void izvrsenjeOperacija() throws IOException, ClassNotFoundException {
        while (!kraj) {
            ObjectInputStream inSocket = new ObjectInputStream(socket.getInputStream());
            TransferObjekat toZahtev = (TransferObjekat) inSocket.readObject();
            TransferObjekat toOdgovor = new TransferObjekat();
            try {
                switch (toZahtev.getOperacija()) {
                    case TransferObjekat.VRATI_ADVOKATE:
                        System.out.println("O: " + TransferObjekat.VRATI_ADVOKATE);
                        toOdgovor.setRezultat(Kontroler.vratiObjekat().vratiAdvokate());
                        break;
                    case TransferObjekat.VRATI_KLIJENTE:
                        System.out.println("O: " + TransferObjekat.VRATI_KLIJENTE);
                        toOdgovor.setRezultat(Kontroler.vratiObjekat().vratiKlijente());
                        break;
                        
                    case TransferObjekat.VRATI_VRSTE_POSTUPAKA:
                        System.out.println("O: " + TransferObjekat.VRATI_VRSTE_POSTUPAKA);
                        toOdgovor.setRezultat(Kontroler.vratiObjekat().vratiVrstePostupaka());
                        break;
                           
                  
                    case TransferObjekat.SACUVAJ_SVE_PREDMETE:
                        System.out.println("O: " + TransferObjekat.SACUVAJ_SVE_PREDMETE);
                        List<Predmet> p = (List<Predmet>) toZahtev.getParametar();
                        Kontroler.vratiObjekat().sacuvajSvePredmete(p);
                        toOdgovor.setRezultat(null);
                        toOdgovor.setSuccess(true);
                        break;
                        
                    case TransferObjekat.VRATI_SIFRU_PREDMETA:
                        System.out.println("O: " + TransferObjekat.VRATI_SIFRU_PREDMETA);
                        toOdgovor.setRezultat(Kontroler.vratiObjekat().vratiNovuSifruPredmeta());
                        break;
                           
                }
                         
            } catch (Exception ex) {
                Logger.getLogger(NitKlijent.class.getName()).log(Level.OFF, ex.getMessage(), ex);
                toOdgovor.setRezultat("Predmeti nisu sacuvani");
                toOdgovor.setIzuzetak(ex);
                toOdgovor.setSuccess(false);
            }
            posaljiOdgovor(toOdgovor);
        }

    }

    private void posaljiOdgovor(TransferObjekat toOdgovor) throws IOException {
        ObjectOutputStream outSocket = new ObjectOutputStream(socket.getOutputStream());
        outSocket.writeObject(toOdgovor);
    }
    
}
