/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package model;

import domen.Proizvod;
import domen.StavkaOtpremnice;
import java.util.ArrayList;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author Mare
 */
public class ModelTabeleStavke extends AbstractTableModel{
    
    String [] columnNames = {"RB", "Proizvod", "Kolicina", "Cena", "Iznos bez PDV", "PDV", "Iznos sa PDV"};
    private ArrayList<StavkaOtpremnice> lista;

    public ModelTabeleStavke(ArrayList<StavkaOtpremnice> lista) {
        this.lista = lista;
    }

    public ModelTabeleStavke() {
        lista = new ArrayList<>();
    }

    public ArrayList<StavkaOtpremnice> getLista() {
        return lista;
    }

    public void setLista(ArrayList<StavkaOtpremnice> lista) {
        this.lista = lista;
    }
    
    

    @Override
    public String getColumnName(int column) {
        return columnNames[column];
    }
    
    
    
    
    

    @Override
    public int getRowCount() {
        return lista.size();
    }

    @Override
    public int getColumnCount() {
       return columnNames.length;      
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        StavkaOtpremnice s = lista.get(rowIndex);
        switch(columnIndex) {
            case 0: return s.getRB();
            case 1: return s.getProizvod();
            case 2: return s.getKolicina();
            case 3: return s.getProizvod().getCenaBezPDV();
            case 4: return s.getIznosBezPDV();
            case 5: return s.getPDV();
            case 6: return s.getIznosSaPDV();
            default: return "";
        }
        
    }

    /*
        Treba ti set value at samo za one kolone koje se menjaju. U ovom slucaju samo proizvod i cena.
        Namestis sve sto treba, odnosno sto se izracunava u zavisnosti od ovih vrednosti (cena, iznos bez pdv, pdv, iznos sa pdv).
        Posle toga obavezno puknes i fireTableRowsUpdated(rowIndex, rowIndex);
    */
    @Override
    public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
         StavkaOtpremnice so = lista.get(rowIndex);
            switch(columnIndex){
           // case 0: so.setRB(Integer.parseInt(aValue.toString())); break;
            case 1: 
                    Proizvod proiz = (Proizvod) aValue;
                    so.setProizvod(proiz); // 
                    
                    double iznosBezPDV = proiz.getCenaBezPDV() * so.getKolicina();
                    so.setIznosBezPDV(iznosBezPDV);
                    
                    double pdv = (proiz.getCenaBezPDV() * so.getKolicina()) * (proiz.getPDV() / 100) ;
                    so.setPDV(pdv);
                    
                    so.setIznosSaPDV(iznosBezPDV + pdv);
                    fireTableRowsUpdated(rowIndex, rowIndex);
                    break;
            case 2: 
                    
                    so.setKolicina(Double.parseDouble(aValue.toString()));
                    
                    iznosBezPDV = so.getProizvod().getCenaBezPDV() * so.getKolicina();
                    so.setIznosBezPDV(iznosBezPDV);
                    
                    pdv = (so.getProizvod().getCenaBezPDV() * so.getKolicina()) * (so.getProizvod().getPDV() / 100) ;
                    so.setPDV(pdv);
                    
                    so.setIznosSaPDV(iznosBezPDV + pdv);
                    fireTableRowsUpdated(rowIndex, rowIndex);
                    break;
          //  case 3: so.getProizvod().setCenaBezPDV(Double.parseDouble(aValue.toString()));break;
          //  case 4: so.setIznosBezPDV(Double.parseDouble(aValue.toString())); break;
         //   case 5: so.setPDV(Double.parseDouble(aValue.toString())); break;
          //  case 6: so.setIznosSaPDV(Double.parseDouble(aValue.toString())); break;
        }
            
    }

    @Override
    public boolean isCellEditable(int rowIndex, int columnIndex) {
        return columnIndex == 1 || columnIndex == 2; // mozes da menjas samo proizvod i kolicinu, ostalo se samo menja
    }
    
    public void dodajRed(StavkaOtpremnice so){
        lista.add(so);
        recalculate(lista); // redni broj ponovo izracunavas
        int row = lista.size() - 1;
        fireTableRowsInserted(row, row); // nema potrebe fireTableDataChanged jer znas koji je red
    }
    
    public void obrisiRed(int rb){
        lista.remove(rb);
        recalculate(lista); // redni broj ponovo izracunavas
        fireTableRowsDeleted(rb, rb); // nema potrebe fireTableDataChanged jer znas koji je red
    }
    
    private void recalculate(ArrayList<StavkaOtpremnice> list){
        int rb = 1;
        for (StavkaOtpremnice so : list){
            so.setRB(rb++);
        }
    }

   
    
    
    
}
