/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package baza;

import domen.Otpremnica;
import domen.PoslovniPartner;
import domen.Proizvod;
import domen.StavkaOtpremnice;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 *
 * @author Mare
 */
public class DatabaseBroker {
    
    private Connection connection;

    public void ucitajDriver() throws Exception {
        Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
    }

    public void otvoriKonekciju() throws Exception {
        connection = DriverManager.getConnection("jdbc:odbc:DejanOstojicOktobar"); // DejanOstojicBaza
        connection.setAutoCommit(false); // Zahteva eksplicitnu potvrdu transakcije
    }

    public void zatvoriKonekciju() throws Exception {
        connection.close();
    }

    public void commitTransakcije() throws Exception {
        try {
            connection.commit();
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new Exception("Transakcija nije potvrdjena!");
        }
    }

    public void rollbackTransakcije() throws Exception {
        try {
            connection.rollback();
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new Exception("Transakcija nije potvrdjena!");
        }
    }
    
     public List<PoslovniPartner> vratiPoslovnePartnere() throws Exception {
        List<PoslovniPartner> lp = new ArrayList<PoslovniPartner>();
        try {
            String sql = "SELECT * FROM PoslovniPartner";
            Statement sqlNaredba = connection.createStatement();
            ResultSet rsTabela = sqlNaredba.executeQuery(sql);
            while (rsTabela.next()) {
                int PoslovniParnerID = rsTabela.getInt("PoslovniPartnerID");
                String Naziv = rsTabela.getString("Naziv");
                int PIB = rsTabela.getInt("PIB");
                int MaticniBroj = rsTabela.getInt("MaticniBroj");
                String Adresa = rsTabela.getString("Adresa");
                PoslovniPartner p = new PoslovniPartner(PoslovniParnerID, Naziv, PIB, MaticniBroj, Adresa);
                lp.add(p);
            }
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new Exception("Greska pri ucitavanju proizvoda!");
        }
        return lp;
    }
     
     public List<Proizvod> vratiSveProizvode() throws Exception {
        List<Proizvod> lpro = new ArrayList<Proizvod>();
        try {
            String sql = "SELECT * FROM Proizvod";
            Statement sqlNaredba = connection.createStatement();
            ResultSet rsTabela = sqlNaredba.executeQuery(sql);
            while (rsTabela.next()) {
                int ProizvodID = rsTabela.getInt("ProizvodID");
                String Naziv = rsTabela.getString("Naziv");
                int CenaBezPDV = rsTabela.getInt("CenaBezPDV");
                int PDV = rsTabela.getInt("PDV");
                Proizvod p = new Proizvod(ProizvodID, Naziv, CenaBezPDV, PDV);
                lpro.add(p);
            }
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new Exception("Greska pri ucitavanju proizvoda!");
        }
        return lpro;
    }
     
     public int vratiNoviBrojOtpremnice() throws SQLException{
         int ret = -1;
         String sql = "select max(OtpremnicaID) as broj from Otpremnica";
         Statement sqlNaredba = connection.createStatement();
         ResultSet rsTabela = sqlNaredba.executeQuery(sql);
         while(rsTabela.next()){
             int broj = rsTabela.getInt("broj");
             ret = broj+1;
         }
         
         
         
         return ret;
     }
     
     public void sacuvajOtpremnicu(Otpremnica o) throws SQLException {
        String sql = "Insert into Otpremnica values (?,?,?,?,?,?)";
        try(PreparedStatement ps = connection.prepareStatement(sql)){ // ovo automatski zatvara resurs u ovom slucaju PreparedStatement
            ps.setInt(1, o.getOtpremnnicaID());
            ps.setDate(2, new java.sql.Date(o.getDatum().getTime()));
            ps.setInt(3, o.getPoslovniPartner().getPoslovniPartnerID());
            ps.setDouble(4, o.getUkupanIznosBezPDV());
            ps.setDouble(5, o.getPDV());
            ps.setDouble(6, o.getUkupanIznosSaPDV());

            ps.executeUpdate();
        }

        
        // int stavkaOtpremniceID = vratiIDStavkeOtpremnice(o.getOtpremnnicaID()); mozemo i bez ovog

        List<StavkaOtpremnice> listaStavki = o.getListaStavkiOtpremnice();
        
        sql = "Insert into StavkaOtpremnice values (?,?,?,?,?,?,?)";
        try(PreparedStatement ps = connection.prepareStatement(sql)){ // isto kao gore

            for (StavkaOtpremnice so : listaStavki) {

                ps.setInt(1, o.getOtpremnnicaID());
                ps.setInt(2, so.getRB()); // rb je drugi deo primarnog kljuca, njega kontrolisemo na klijentu
                ps.setInt(3, so.getProizvod().getProizvodID());
                ps.setDouble(4, so.getKolicina());
                ps.setDouble(5, so.getIznosBezPDV());
                ps.setDouble(6, so.getPDV());
                ps.setDouble(7, so.getIznosSaPDV());

                ps.executeUpdate();
            }
            
        }
    }
     
     private int vratiIDStavkeOtpremnice(int idF) throws SQLException {
        String sql = "Select MAX(RB) from StavkaOtpremnice where OtpremnicaID=" + idF;
        Statement s = connection.createStatement();
        ResultSet rs = s.executeQuery(sql);
        rs.next();
        int id = rs.getInt(1) + 1;
        return id;
    }
     
      public List<Otpremnica> vratiSveOtpremnice(Date from, Date to) throws Exception {
        List<Otpremnica> lo = new ArrayList<>();
        try {
            
            java.sql.Date dateTo = to == null ? null : new java.sql.Date(to.getTime());
            java.sql.Date dateFrom = from == null ? null : new java.sql.Date(from.getTime());
            
            String sql = "SELECT OtpremnicaID,Datum,PoslovniPartnerID,UkupanIznosBezPDV,PDV,UkupanIznosSaPDV FROM Otpremnica where  true ";
            
            if (dateFrom != null){
                sql = sql + " and Datum >= " + "{d '" + dateFrom + "'}";
            }
            if (dateTo != null){
                sql = sql + " and Datum <= {d '" +  dateTo +"'}";
            }
            
            System.out.println("DEBG :: INFO :: SQL : " + sql);
            
            Statement sqlNaredba = connection.createStatement();
            ResultSet rsTabela = sqlNaredba.executeQuery(sql);
            while (rsTabela.next()) {
                int OtpremnicaID = rsTabela.getInt("OtpremnicaID");
                java.util.Date Datum = rsTabela.getDate("Datum");
                int PoslovniPartnerID = rsTabela.getInt("PoslovniPartnerID");        
                PoslovniPartner pp = getPPById(PoslovniPartnerID);
                double UkupanIznosBezPDV = rsTabela.getDouble("UkupanIznosBezPDV");        
                double PDV = rsTabela.getDouble("PDV");        
                double UkupanIznosSaPDV = rsTabela.getDouble("UkupanIznosSaPDV");        
                Otpremnica o = new Otpremnica();
                o.setOtpremnnicaID(OtpremnicaID);
                o.setDatum(Datum);
                o.setPoslovniPartner(pp);
                o.setUkupanIznosBezPDV(UkupanIznosBezPDV);
                o.setUkupanIznosSaPDV(UkupanIznosSaPDV);
                o.setPDV(PDV);
                lo.add(o);
            }
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new Exception("Greska pri ucitavanju proizvoda!");
        }
        return lo;
    }
      
     public PoslovniPartner getPPById(int id) throws SQLException {
        try {
            String sql = "SELECT PoslovniPartnerID,Naziv,PIB,MaticniBroj,Adresa FROM PoslovniPartner where PoslovniPartnerID=" + id;
            Statement sqlNaredba = connection.createStatement();
            ResultSet rs = sqlNaredba.executeQuery(sql);
            if (rs.next()) {
                int PoslovniPartnerID = rs.getInt("PoslovniPartnerID");
                String Naziv = rs.getString("Naziv");
                int pib = rs.getInt("PIB");
                int MaticniBroj = rs.getInt("MaticniBroj");
                String Adresa = rs.getString("Adresa");
                
                return new PoslovniPartner(PoslovniPartnerID, Naziv, pib, MaticniBroj, Adresa);
            }
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new SQLException("Greska pri ucitavanju proizvoda!");
        }
        return null;
    }
    
}
