/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package forma;

import domen.Otpremnica;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author dostojic
 */
public class PretragaTableModel extends AbstractTableModel{

    private List<Otpremnica> otpremnice;
    private final String [] columnNames = {"Broj otpremnice", "Datum", "Partner", "PDV", "Ukupno sa PDV"};
    public PretragaTableModel() {
        otpremnice = new ArrayList<>();
    }

    public PretragaTableModel(List<Otpremnica> otpremnice) {
        this.otpremnice = otpremnice;
    }
    
    
    @Override
    public int getRowCount() {
        return otpremnice.size();
    }

    @Override
    public int getColumnCount() {
        return columnNames.length;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        Otpremnica o = otpremnice.get(rowIndex);
        switch (columnIndex){
            case 0: return o.getOtpremnnicaID();
            case 1: return new SimpleDateFormat("dd.MM.yyyy").format(o.getDatum());
            case 2: return o.getPoslovniPartner().getNaziv();
            case 3: return o.getUkupanIznosBezPDV();
            case 4: return o.getPDV();
            case 5: return o.getUkupanIznosSaPDV();
        }
        return "no value";
    }

    public void setOtpremnice(List<Otpremnica> otpremnice) {
        this.otpremnice = otpremnice;
        fireTableDataChanged();
    }
    
}
