/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package kontroler;

import baza.DatabaseBroker;
import domen.Otpremnica;
import domen.PoslovniPartner;
import domen.Proizvod;
import java.sql.SQLException;
import java.util.Date;
import java.util.List;

/**
 *
 * @author Mare
 */
public class Kontroler {
    
    private DatabaseBroker db;
    private static Kontroler k;

    private Kontroler() {
        db = new DatabaseBroker();
    }

    public static Kontroler vratiObjekat() {
        if (k == null) {
            k = new Kontroler();
        }
        return k;
    }
    
       public List<PoslovniPartner> vratiPoslovnePartnere() throws Exception {
        db.ucitajDriver();
        db.otvoriKonekciju();
        List<PoslovniPartner> listaPoslovnihPartnera = db.vratiPoslovnePartnere();
        db.commitTransakcije();
        db.zatvoriKonekciju();
        return listaPoslovnihPartnera;
    }
       
       public List<Proizvod> vratiSveProizvode() throws Exception {
        db.ucitajDriver();
        db.otvoriKonekciju();
        List<Proizvod> listaProizvoda = db.vratiSveProizvode();
        db.commitTransakcije();
        db.zatvoriKonekciju();
        return listaProizvoda;
    }
       
       public int vratiNoviBrojOtpremnice() throws Exception {
        db.ucitajDriver();
        db.otvoriKonekciju();
        int broj = db.vratiNoviBrojOtpremnice();
        db.commitTransakcije();
        db.zatvoriKonekciju();
        return broj;
    }
       
    public void sacuvajOtpremnicu(Otpremnica o) throws SQLException, Exception{
        db.ucitajDriver();
        db.otvoriKonekciju();
        try{
            db.sacuvajOtpremnicu(o); // pokusas da sacuvas
            db.commitTransakcije();  // ako prodje komitujes
        }catch(SQLException e){     // db.sacuvajOtpremnicu metoda baca sql exception ako ne moze da sacuva, mi ovde hvatamo
            db.rollbackTransakcije(); // radimo rollback jer ne zelimo da napravimo situaciju da je sacuvana otpremnica, i recimo prve 3 stavke, a poslednjih 8 nije
            throw e; // bacamo exception da mozemo da ga obradimo kasnije
        }finally{ // uvek na kraju cistimo resurse!
            db.zatvoriKonekciju(); 
        }
        
    }
    
    public List<Otpremnica>  vratiOtpremnice(Date from, Date to)throws SQLException,Exception{
        db.ucitajDriver();
        db.otvoriKonekciju();
        List<Otpremnica> listaOtpremnica = db.vratiSveOtpremnice(from, to);
        db.commitTransakcije();
        db.zatvoriKonekciju();
        return listaOtpremnica;
    }
    
    
}
