/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package server;

import TransferObjekat.TransferObjekat;
import domen.Otpremnica;
import domen.Proizvod;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import kontroler.Kontroler;

/**
 *
 * @author Mare
 */
public class NitKlijent extends Thread{
    
    Socket socket;
    boolean kraj;

    public NitKlijent(Socket socket) {
        this.socket=socket;
    }
    
    public void run(){
        try {
            izvrsenjeOperacija();
        } catch (IOException ex) {
            Logger.getLogger(NitKlijent.class.getName()).log(Level.SEVERE, null, ex);
        } catch (ClassNotFoundException ex) {
            Logger.getLogger(NitKlijent.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
    
    public void izvrsenjeOperacija() throws IOException, ClassNotFoundException {
        while (!kraj) {
            ObjectInputStream inSocket = new ObjectInputStream(socket.getInputStream());
            TransferObjekat toZahtev = (TransferObjekat) inSocket.readObject();
            TransferObjekat toOdgovor = new TransferObjekat();
            try {
                switch (toZahtev.getOperacija()) {
                    case TransferObjekat.VRATI_POSLOVNE_PARTNERE:
                        System.out.println("O: " + TransferObjekat.VRATI_POSLOVNE_PARTNERE);
                        toOdgovor.setRezultat(Kontroler.vratiObjekat().vratiPoslovnePartnere());
                        break;
                    case TransferObjekat.VRATI_BROJ:
                        System.out.println("O: " + TransferObjekat.VRATI_BROJ);
                        toOdgovor.setRezultat(Kontroler.vratiObjekat().vratiNoviBrojOtpremnice());
                        break;
                    case TransferObjekat.VRATI_PROIZVODE:
                        System.out.println("O: " + TransferObjekat.VRATI_PROIZVODE);
                        toOdgovor.setRezultat(Kontroler.vratiObjekat().vratiSveProizvode());
                        break;
                    case TransferObjekat.SACUVAJ_OTPREMNICU:
                        System.out.println("O: " + TransferObjekat.SACUVAJ_OTPREMNICU);
                        Otpremnica o = (Otpremnica) toZahtev.getParametar(); // citas parametar i kastujes ga u otpremnicu jer znas da je ta klasa (jbg ti si ga poslao sa klijenta)
                        Kontroler.vratiObjekat().sacuvajOtpremnicu(o);
                        toOdgovor.setRezultat(null);
                        toOdgovor.setSuccess(true);
                        break;
                }
            } catch (Exception ex) {
                Logger.getLogger(NitKlijent.class.getName()).log(Level.OFF, ex.getMessage(), ex);
                toOdgovor.setRezultat("Mesto nije sacuvano");
                toOdgovor.setIzuzetak(ex);
                toOdgovor.setSuccess(false);
            }
            posaljiOdgovor(toOdgovor);
        }

    }

    private void posaljiOdgovor(TransferObjekat toOdgovor) throws IOException {
        ObjectOutputStream outSocket = new ObjectOutputStream(socket.getOutputStream());
        outSocket.writeObject(toOdgovor);
    }
    
}
