/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package domen;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
 *
 * @author Mare
 */
public class Otpremnica implements Serializable{
    
    private int OtpremnnicaID;
    private Date Datum;
    private PoslovniPartner poslovniPartner;
    private double UkupanIznosBezPDV;
    private double PDV;
    private double UkupanIznosSaPDV;
     private List<StavkaOtpremnice> listaStavkiOtpremnice;

    public Otpremnica() {
    }

    /**
     * Ovde primas samo listu otpremnica, pa zavisne vrednosti izracunavas na osnovu stavki
     * 
     * @param OtpremnnicaID
     * @param Datum
     * @param poslovniPartner
     * @param listaStavkiOtpremnice
     */
    public Otpremnica(int OtpremnnicaID, Date Datum, PoslovniPartner poslovniPartner, List<StavkaOtpremnice> listaStavkiOtpremnice) {
        this.OtpremnnicaID = OtpremnnicaID;
        this.Datum = Datum;
        this.poslovniPartner = poslovniPartner;
        this.listaStavkiOtpremnice = listaStavkiOtpremnice;
        // ovo je moglo i da stoji u seteru za "listaStavkiOtpremnice"
        setUkupanIznosSaPDV(calculateUkupanIznosSaPDV(listaStavkiOtpremnice));
        setUkupanIznosBezPDV(calculateUkupanIznosBezPDV(listaStavkiOtpremnice));
        setPDV(calculatePDV(listaStavkiOtpremnice));
    }
    
    

    public Otpremnica(int OtpremnnicaID, Date Datum, PoslovniPartner poslovniPartner, double UkupanIznosBezPDV, double PDV, double UkupanIznosSaPDV, List<StavkaOtpremnice> listaStavkiOtpremnice) {
        this.OtpremnnicaID = OtpremnnicaID;
        this.Datum = Datum;
        this.poslovniPartner = poslovniPartner;
        this.UkupanIznosBezPDV = UkupanIznosBezPDV;
        this.PDV = PDV;
        this.UkupanIznosSaPDV = UkupanIznosSaPDV;
        this.listaStavkiOtpremnice = listaStavkiOtpremnice;
    }
    
    

    public double getUkupanIznosSaPDV() {
        return UkupanIznosSaPDV;
    }

    public void setUkupanIznosSaPDV(double UkupanIznosSaPDV) {
        this.UkupanIznosSaPDV = UkupanIznosSaPDV;
    }

    public int getOtpremnnicaID() {
        return OtpremnnicaID;
    }

    public void setOtpremnnicaID(int OtpremnnicaID) {
        this.OtpremnnicaID = OtpremnnicaID;
    }

    public Date getDatum() {
        return Datum;
    }

    public void setDatum(Date Datum) {
        this.Datum = Datum;
    }

    public PoslovniPartner getPoslovniPartner() {
        return poslovniPartner;
    }

    public void setPoslovniPartner(PoslovniPartner poslovniPartner) {
        this.poslovniPartner = poslovniPartner;
    }

    public double getUkupanIznosBezPDV() {
        return UkupanIznosBezPDV;
    }

    public void setUkupanIznosBezPDV(double UkupanIznosBezPDV) {
        this.UkupanIznosBezPDV = UkupanIznosBezPDV;
    }

    public double getPDV() {
        return PDV;
    }

    public void setPDV(double PDV) {
        this.PDV = PDV;
    }

    public List<StavkaOtpremnice> getListaStavkiOtpremnice() {
        return listaStavkiOtpremnice;
    }

    public void setListaStavkiOtpremnice(List<StavkaOtpremnice> listaStavkiOtpremnice) {
        this.listaStavkiOtpremnice = listaStavkiOtpremnice;
        
    }
    
    public double calculateUkupanIznosBezPDV(List<StavkaOtpremnice> listaStavkiOtpremnice){
        double ukupanIznosBezPDV = 0;
        for (StavkaOtpremnice so : listaStavkiOtpremnice){
            ukupanIznosBezPDV = ukupanIznosBezPDV + so.getIznosBezPDV();
        }
        return ukupanIznosBezPDV;
    }
    
    public double calculatePDV(List<StavkaOtpremnice> listaStavkiOtpremnice){
        double ukupanIznosPDV = 0;
        for (StavkaOtpremnice so : listaStavkiOtpremnice){
            ukupanIznosPDV = ukupanIznosPDV + so.getPDV();
        }
        return ukupanIznosPDV;
    }
    
public double calculateUkupanIznosSaPDV(List<StavkaOtpremnice> listaStavkiOtpremnice){
        double ukupanIznosSaPDV = 0;
        for (StavkaOtpremnice so : listaStavkiOtpremnice){
            ukupanIznosSaPDV = ukupanIznosSaPDV + so.getIznosSaPDV();
        }
        return ukupanIznosSaPDV;
    }
    
    
    
}
