/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package kontroler;

import domen.ApstraktniObjekat;
import domen.Lekar;
import domen.OsiguranoLice;
import domen.Prioritet;
import domen.TransferObjekat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import klijent.Klijent;
import operacija.Operacija;

/**
 *
 * @author Mare
 */
public class Kontroler {
    
    private static Kontroler kontroler;
    private ArrayList <Lekar> listaLekara;
    private ArrayList <OsiguranoLice> listaOsiguranihLica;
    private ArrayList <Prioritet> listaPrioriteta;
    private TransferObjekat transferObjekat;
    private Klijent klijent;
    
    public Kontroler() {
        transferObjekat = new TransferObjekat();
    }
    
    public static Kontroler getKontroler(){
    if(kontroler == null){
      kontroler = new Kontroler();
    }
    return kontroler;
   }
    
    public boolean KonektujKlijenta(String adr, int port) {
        try {
            klijent = new Klijent(adr, port);
            klijent.start();
            return true;
        } catch (Exception e) {
            e.printStackTrace();
            return false;
        }
    }
    
    public ArrayList<Lekar> getListaLekara() {
        return listaLekara;
    }

    public void setListaLekara(ArrayList<Lekar> listaLekara) {
        this.listaLekara = listaLekara;
    }

    public ArrayList<OsiguranoLice> getListaOsiguranihLica() {
        return listaOsiguranihLica;
    }

    public void setListaOsiguranihLica(ArrayList<OsiguranoLice> listaOsiguranihLica) {
        this.listaOsiguranihLica = listaOsiguranihLica;
    }

    public ArrayList<Prioritet> getListaPrioriteta() {
        return listaPrioriteta;
    }

    public void setListaPrioriteta(ArrayList<Prioritet> listaPrioriteta) {
        this.listaPrioriteta = listaPrioriteta;
    }
    
     public boolean izvrsi(ApstraktniObjekat apstraktniObjekat) {
        transferObjekat.setObjekat(apstraktniObjekat);
        klijent.posalji(transferObjekat);
        transferObjekat = klijent.prihvati();
        return (boolean) transferObjekat.getObjekat();
    }
    
    
    
    private boolean unos(ApstraktniObjekat apstraktniObjekat) {
        apstraktniObjekat.setOperacija(Operacija.UNOS);
        return izvrsi(apstraktniObjekat);
    }

    private boolean izmena(ApstraktniObjekat apstraktniObjekat) {
        apstraktniObjekat.setOperacija(Operacija.IZMENA);
        return izvrsi(apstraktniObjekat);
    }

    private boolean brisanje(ApstraktniObjekat apstraktniObjekat) {
        apstraktniObjekat.setOperacija(Operacija.BRISANJE);
        return izvrsi(apstraktniObjekat);
    }

    public List vratiListu(ApstraktniObjekat apstraktniObjekat) {
        apstraktniObjekat.setOperacija(Operacija.VRATI_LISTU);
        transferObjekat.setObjekat(apstraktniObjekat);
        klijent.posalji(transferObjekat);
        transferObjekat = klijent.prihvati();
        return (List) transferObjekat.getObjekat();

    }
    
    public void vratiListuLekara(){
     Lekar lekar = new Lekar();
     listaLekara = (ArrayList<Lekar>) vratiListu(lekar);
    }
    
    public void vratiListuOsiguranihLica(){
     OsiguranoLice osiguranoLice = new OsiguranoLice();
     listaOsiguranihLica = (ArrayList<OsiguranoLice>) vratiListu(osiguranoLice);
    }
    
    public void vratiListuPrioriteta() {
           Prioritet prioritet = new Prioritet();
           listaPrioriteta = (ArrayList<Prioritet>) vratiListu(prioritet);
    }
    
 //public boolean unosPrijava(Student student, Predmet predmet, Date datum, String profesor, int ocena) {
   //     Prijava prijava = new Prijava(student, predmet, datum, profesor, ocena);
     //   return unos(prijava);
    //}   
            
    
}
