/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package dbbr;

import domen.ApstraktniObjekat;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.Statement;
import java.util.List;
import operacija.Operacija;

/**
 *
 * @author Mare
 */
public class DatabaseBroker {
    
    private Connection konekcija;
    private Statement iskaz;
    private static DatabaseBroker databaseBroker;

    public DatabaseBroker() {
    }
    
    
    public static DatabaseBroker getDatabaseBroker(){
     if(databaseBroker == null){
      databaseBroker = new DatabaseBroker();
     }
     return databaseBroker;
    }
    
    public boolean otvoriBazu(){
      try {
           Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
     konekcija = DriverManager.getConnection("jdbc:odbc:IspitSeptembar");
        return true;
        } catch (Exception e) {
            e.printStackTrace();
            return false;
        }
    } 
    
    public void zatvoriBazu(){
        try {
            konekcija.close();
            
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    public boolean commitTransakciju(){
        try {
            konekcija.commit();
            return true;
        } catch (Exception e) {
         e.printStackTrace();
            return false;
         
        }
    }
    
    public void rollbackTransakcije(){
        try {
            konekcija.rollback();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    public String dajUpit(ApstraktniObjekat apstraktniObjekat){
       switch(apstraktniObjekat.getOperacija()){
           case Operacija.UNOS:
               return apstraktniObjekat.unos();
           case Operacija.IZMENA:
               return apstraktniObjekat.izmena();
           case Operacija.BRISANJE:
               return apstraktniObjekat.brisanje();
           case Operacija.VRATI_LISTU:
               return apstraktniObjekat.vratiListu();
               default:return null;
       }
    }
   
     public boolean izvrsi(ApstraktniObjekat apstraktniObjekat){
      if(!otvoriBazu()){
       return false;
      }
      boolean uspesno = false;
      try{
       
      iskaz = konekcija.createStatement();
      iskaz.executeUpdate(dajUpit(apstraktniObjekat));
      iskaz.close();
      if(commitTransakciju()){
      
      uspesno = true;
      }else{
          
       rollbackTransakcije();
       uspesno = false;
      }
      }
    catch(Exception e){
        zatvoriBazu();
        uspesno = false;
    }
      return uspesno;
    }
    
      public List vratiListu(ApstraktniObjekat apstraktniObjekat){
      if(!otvoriBazu()){
       return null;
      }
      List lista = null;
      try{
      iskaz = konekcija.createStatement();
      lista = apstraktniObjekat.napuniListu(iskaz.executeQuery(dajUpit(apstraktniObjekat)));
      iskaz.close();
      return lista;
      }
    catch(Exception e){
       
        return null;
    }
    }
    
    
}
