/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package server;

import dbbr.DatabaseBroker;
import domen.ApstraktniObjekat;
import domen.TransferObjekat;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import operacija.Operacija;

/**
 *
 * @author Mare
 */
public class ServerThread extends Thread{
    
    private Server server;
     private Socket socket;
    ObjectOutputStream out;
    ObjectInputStream in;

    public ServerThread(Server server, Socket socket) {
        this.server = server;
        this.socket = socket;
    }

    public void posalji(TransferObjekat transferObjekat){
        try {
            out = new ObjectOutputStream(socket.getOutputStream());
            out.writeObject(transferObjekat);
        } catch (Exception e) {
        }
    }
    
    public TransferObjekat prihvati(){
        try {
            in = new ObjectInputStream(socket.getInputStream());
            return (TransferObjekat) in.readObject();
        } catch (Exception e) {
            e.printStackTrace();
           return null;
        }
        
    }
    
    public void run(){
        while (true) {            
            try {
                TransferObjekat transferObjekat = prihvati();
                ApstraktniObjekat apstraktniObjekat = (ApstraktniObjekat) transferObjekat.getObjekat();
                switch(apstraktniObjekat.getOperacija()){
                    case Operacija.UNOS:
                    case Operacija.IZMENA:
                    case Operacija.BRISANJE:
                        transferObjekat.setObjekat(DatabaseBroker.getDatabaseBroker().izvrsi(apstraktniObjekat));
                        break;
                    case Operacija.VRATI_LISTU:
                        transferObjekat.setObjekat(DatabaseBroker.getDatabaseBroker().vratiListu(apstraktniObjekat));
                        break;
                }
                posalji(transferObjekat);
            } catch (Exception e) {
                e.printStackTrace();
                break;
            }
        }
        kraj();
    }
    
    public void kraj(){
        try {
            in.close();
            out.close();
            socket.close();
            in = null;
            out = null;
            socket = null;
            server = null;
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    
}
